﻿@inject ILoaderConfiguration configurations

@if ( FullPage ) {
    <div Class="@( IsLoading ? "loading-overlay" : "" )" style="background-color: @(BackgroundColor)">
        <SpinLoader Center="true" Spinner="Spinner.Value" Color="@Color" Size="@Size" IsLoading="@(IsLoading)">
            <ContentTemplate>
            </ContentTemplate>
        </SpinLoader>
    </div>
    @if ( !IsLoading )
        @ChildContent
} else {
    <SpinLoader Spinner="Spinner.Value" IsLoading="IsLoading">
        <ContentTemplate>
            @ChildContent
        </ContentTemplate>
        <LoadingTemplate>
            <div Class="@("loading " + Class)" style="background-color: @(BackgroundColor)">
                <div Class="loading-internal">
                    @switch ( Spinner.Value ) {
                        case SpinnerType.Bounce:
                            <Bounce Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Chase:
                            <Chase Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.CircleFade:
                            <CircleFade Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Flow:
                            <Flow Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Fold:
                            <Fold Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Grid:
                            <Grid Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Plane:
                            <Plane Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Pulse:
                            <Pulse Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Swing:
                            <Swing Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Wander:
                            <Wander Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Wave:
                            <Wave Color="@Color" Size="@Size" Center="true" />
                            break;
                        case SpinnerType.Circle:
                        default:
                            <Circle Color="@Color" Size="@Size" Center="true" />
                            break;
                    }
                </div>
            </div>
        </LoadingTemplate>
    </SpinLoader>
}

@code {
    [Parameter]
    public bool IsLoading { get; set; }

    [Parameter]
    public RenderFragment ChildContent { get; set; }

    [Parameter]
    public SpinnerType? Spinner { get; set; }

    [Parameter]
    public string Class { get; set; }

    [Parameter]
    public string Size { get; set; }

    [Parameter]
    public string Color { get; set; }

    [Parameter]
    public string BackgroundColor { get; set; }

    private bool FullPage { get => ChildContent == null; }

    protected override void OnInitialized( ) {

        if ( !Spinner.HasValue )
            Spinner = configurations.Spinner;

        if ( string.IsNullOrEmpty( Color ) )
            Color = configurations.Color;

        if ( string.IsNullOrEmpty( BackgroundColor ) )
            BackgroundColor = configurations.BackgroundColor;

        if ( string.IsNullOrEmpty( Size ) )
            if ( FullPage ) {
                Size = configurations.FullPageSize;
            } else
                Size = configurations.Size;

        base.OnInitialized( );
    }
}